<!-- 专业装备 -->
<template>
  <div>
    <el-dialog
      :before-close="handleClose"
      :close-on-click-modal="false"
      :visible="visible"
      custom-class="bbsl-location-dialog"
      title="课目"
      top="5vh"
      width="75%"
    >
      <el-container>
        <!-- <el-aside width="230px" class="left-aside">
					<el-card class="box-card org-find-card" shadow="never">
						<div slot="header" class="clearfix">
							<span>按专业装备查找</span>
						</div>
						<div class="common-tree-container">
							<div class="container-head">
								<el-input placeholder="输入关键字进行过滤" v-model="filterText" clearable>
								</el-input>
								<i class="el-icon-s-fold" @click="expandHandle" v-if="expandAll" ></i>
								<i class="el-icon-s-unfold" @click="expandHandle" v-else ></i>
							</div>

							<el-tree highlight-current ref="tree" :data="treeData" :props="defaultProps" :expand-on-click-node="expandAll"   :default-expanded-keys="expandedKeys"
								node-key="newId" :current-node-key="currentKey"  :filter-node-method="filterNode"
								@node-click="handleNodeClick">
							</el-tree>
						</div>
					</el-card>
				</el-aside> -->
        <el-container>
          <el-header class="middle-header">
            <div style="padding: 10px 0">
              <el-input
                v-model="querys[1].value"
                clearable
                placeholder="请输入名称"
                prefix-icon="el-icon-search"
                size="small"
                style="width:50%"
                @keyup.enter.native="searchEnterFun"
              >
              </el-input>
              <el-button
                icon="el-icon-search"
                size="small"
                style="margin-left: 20px"
                type="primary"
                @click="searchEnterFun()"
                >查询
              </el-button>
              <!-- <el-button size="small" @click="reset()" icon="el-icon-refresh">重置</el-button> -->
            </div>
          </el-header>
          <el-main style="padding:0">
            <el-table
              ref="multipleSelection"
              :data="UserData"
              :row-key="binRowKey"
              border
              height="400"
              size="medium"
              stripe
              @select="manualSelection"
            >
              <el-table-column
                :reserve-selection="true"
                align="center"
                type="selection"
                width="45"
              >
              </el-table-column>
              <el-table-column label="课目信息" prop="name"></el-table-column>
              <el-table-column
                label="训练类别"
                prop="trainTypeName"
              ></el-table-column>
            </el-table>
          </el-main>
          <el-pagination
            ref="paginationPanel"
            :current-page="queryParam.pageBean.page"
            :page-size="queryParam.pageBean.pageSize"
            :page-sizes="[20, 30, 40, 50]"
            :total="total"
            align="right"
            background
            layout="prev, pager, next,total, sizes, jumper"
            @size-change="handleSizeChange"
            @current-change="handleCurrentChange"
          ></el-pagination>
        </el-container>
        <el-aside class="select-aside" width="200px">
          <el-card class="box-card org-find-card" shadow="never">
            <div slot="header" class="clearfix">
              <span>已选择</span>
            </div>
            <div class="common-tree-container">
              <el-tree
                ref="selectTree"
                :data="selectUser"
                :props="selectUserProps"
                node-key="name"
              >
              </el-tree>
            </div>
          </el-card>
        </el-aside>
      </el-container>
      <span slot="footer" class="dialog-footer" style="text-align: center;">
        <el-button size="small" type="primary" @click="dialogConfirm"
          >确认</el-button
        >
        <el-button size="small" @click="handleClose">取消</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import {TableMixin} from '@/mixins/tableMixin'
import dictUtils from '@/components/dict/DictSelectUtils.js'
import questionListMenu from '@/api/examination/questionListMenu.js'
// import questionListMenu from '@/api/examination/questionListMenu.js'
export default {
  mixins: [TableMixin],
  name: 'SelectOrganize',
  props: ['userTypeId'],
  data() {
    return {
      querys: [
        {
          group: 'main',
          operation: 'LIKE',
          parentGroup: '',
          property: 'po.full_id_',
          relation: 'AND',
          value: ''
        },
        {
          group: 'main',
          operation: 'RIGHT_LIKE',
          parentGroup: '',
          property: 'name',
          relation: 'AND',
          value: ''
        },
        {
          group: 'main',
          operation: 'RIGHT_LIKE',
          parentGroup: '',
          property: 'name',
          relation: 'AND',
          value: ''
        }
      ],
      newParam: {
        pageBean: {
          pageSize: 20,
          page: 1
        },
        querys: [
          {
            group: 'main',
            operation: 'RIGHT_LIKE',
            parentGroup: '',
            property: 'name',
            relation: 'AND',
            value: ''
          }
        ]
      },

      search: '',
      treeData: [],
      defaultProps: {
        children: 'children',
        label: 'name'
      },
      visible: false,
      UserData: [],
      selectUser: [],
      selectUserProps: {
        label: 'name'
      },
      nameArr: [],
      multipleSelection: null,
      params: {
        majorIds: [],
        subjectIds: []
      },
      userlength: null,
      userInfoVos: [],
      id: '',
      currentKey: null,
      filterText: '',
      expandAll: true,
      expandedKeys: []
    }
  },
  created() {
    this.trainTypeList = dictUtils.getDictItemsFromCache('xllb')
  },
  mounted() {},
  watch: {
    // filterText(val) {
    // 	this.$refs.tree.filter(val);
    // },
    // currentKey: {
    // 	handler(value) {
    // 		if (value) {
    // 			this.$nextTick(
    // 		() => {
    // 			console.log(1,this.currentKey);
    // 			console.log(this.treeData);
    // 				this.$refs.tree.setCurrentKey(this.currentKey);
    // 			});
    // 		}
    // 	},
    // 	immediate: true,
    // 	valType:false
    // },
  },
  methods: {
    // expandHandle() {
    //       console.log(this.$refs.tree.store);
    //       this.expandAll = !this.expandAll;
    //       this.expandNodes(this.$refs.tree.store.root);
    //     },
    //     // 遍历树形数据，设置每一项的expanded属性，实现展开收起
    //     expandNodes(node) {
    //       node.expanded = this.expandAll;
    //       for (let i = 0; i < node.childNodes.length; i++) {
    //         node.childNodes[i].expanded = this.expandAll;
    //         if (node.childNodes[i].childNodes.length > 0) {
    //           this.expandNodes(node.childNodes[i]);
    //         }
    //       }
    //     },
    // filterNode(value, data) {
    // 	if (!value) return true;
    // 	return data.name.indexOf(value) !== -1;
    // },
    add(val, id, parentId) {
      this.currentKey = ''
      this.getTree(1, id, parentId)
      this.selectUser = []
      this.visible = true
      if (val) {
        this.userInfoVos = val
        this.selectUser = JSON.parse(JSON.stringify(val))
        this.userlength = val.length
      }
      this.multipleSelection = null
    },
    // 获取列表
    loadData(page) {
      if (page) {
        this.queryParam.pageBean.page = page
      }
      this.UserData = []
      this.queryParam.querys = []
      if (this.querys[0].value) {
        this.queryParam.querys.push(this.querys[0])
      }
      if (this.querys[1].value) {
        this.queryParam.querys.push(this.querys[1])
      }
      questionListMenu.findByMajorIds(this.queryParam, res => {
        this.total = res.total
        this.UserData = res.rows
        this.UserData.forEach(u => {
          this.trainTypeList.forEach(e => {
            if (u.trainType == e.value) {
              u.trainTypeName = e.name
            }
          })
        })
      })
      this.$set(this.UserData)
    },
    // 获取人员类别树
    getTree(page, id, parentId) {
      if (page) {
        this.newParam.pageBean.page = page
      }
      questionListMenu.majorQuery(this.newParam, res => {
        this.treeData = res.value
        this.treeData.forEach(a => {
          a.newId = a.parentId + a.id
          if (a.children) {
            a.children.forEach(b => {
              b.newId = b.parentId + b.id
              if (b.children) {
                b.children.forEach(c => {
                  c.newId = c.parentId + c.id
                })
              }
            })
          }
        })
        this.$set(this.treeData)
        if (id) {
          this.currentKey = parentId + id
          this.expandedKeys.push(this.currentKey)
          this.querys[0].value = id
        }
        this.loadData(1)
        // console.log(this.treeData);
      })
    },
    // 显示
    handleShow(val) {
      this.visible = true
      this.selectUser = []
      this.multipleSelection = null
      this.getTree(1)
      this.loadData(1)
    },

    // 关闭新增人员窗口
    handleClose() {
      this.visible = false
      this.treeData = [
        {
          code: '',
          id: '',
          name: '专业装备',
          type: 0,
          children: []
        }
      ]
      this.UserData = []
      this.selectUser = []
    },
    // 树
    handleNodeClick(item) {
      // this.currentKey = item.id
      this.querys[0].value = item.id
      this.loadData(1)
    },
    // 中间列表
    searchEnterFun() {
      this.loadData(1)
    },
    // 重置
    reset() {
      this.querys[0].value = ''
      this.querys[1].value = ''
      this.loadData(1)
    },
    dialogConfirm() {
      this.$emit('getUser', this.selectUser)
      this.handleClose()
    },
    binRowKey(row) {
      return row.id
    },
    selectable(row) {
      let type = true
      this.userInfoVos.forEach((u, ui) => {
        if (ui <= this.userlength) {
          if (row.id == u.id) {
            type = false
          }
        }
      })
      return type
      // return true
    },
    manualSelection(selection, row) {
      console.log(selection, row)
      this.selectUser = []
      this.selectUser.push(row)
      this.multipleSelection = row
      // 清除 所有勾选项
      this.$refs.multipleSelection.clearSelection()
      // 当表格数据都没有被勾选的时候 就返回
      // 主要用于将当前勾选的表格状态清除
      if (selection.length == 0) return
      this.$refs.multipleSelection.toggleRowSelection(row, true)
      // 	console.log(row);
      // 	//先判断当前操作flag
      // 	//true勾选还是false取消
      // 	let flag = selection.some((item) => {
      // 		if (row.id == item.id) return true;
      // 	})
      // 	if (flag) {
      // 		this.selectUser.push(row)
      // 	} else {
      // 		this.selectUser.forEach((s, si) => {
      // 			if (s.id == row.id) {
      // 				this.selectUser.splice(si, 1)

      // 			}
      // 		})
      // 	}
    }
    // handleSelectionChange(val) {
    // 	this.selectUser = val
    // 	this.multipleSelection = row;
    // 	// 清除 所有勾选项
    // 	this.$refs.multipleSelection.clearSelection()
    // 	// 当表格数据都没有被勾选的时候 就返回
    // 	// 主要用于将当前勾选的表格状态清除
    // 	if (selection.length == 0) return
    // 	this.$refs.multipleSelection.toggleRowSelection(row, true);
    // },
  }
}
</script>

<style lang="scss" scoped>
::v-deep .el-dialog__body {
  height: 100% !important;
  max-height: 80%;
}

.left-aside {
  margin-right: 10px;
}

.select-aside {
  margin-left: 10px;

  ::v-deep .el-card__body {
    padding: 0 !important;
  }
}

.el-card {
  height: 99% !important;
}

.el-tree {
  max-height: 400px;
  overflow-y: auto;
  border: none;
}

.select-header {
  border-bottom: 1px solid #ebeef5;
}

::v-deep .el-table__header-wrapper .el-checkbox {
  //找到表头那一行，然后把里面的复选框隐藏掉
  display: none;
}

.container-head {
  display: flex;
  align-items: center;

  i {
    font-size: 28px;
  }
}
</style>
